polybori::groebner::PairManager Class Reference

This class defines PairManager. More...

`#include <PairManager.h>`

Inheritance diagram for polybori::groebner::PairManager:

## Public Types

typedef std::priority_queue< Pair, std::vector< PairE >, PairECompare > | queue_type

## Public Member Functions

| PairManager (const BoolePolyRing &ring)
void | appendHiddenGenerators (std::vector< Polynomial > &vec)
void | introducePair (const Pair &pair, bool isHFE)
Polynomial | nextSpoly (ReductionStrategy &gen)
bool | pairSetEmpty () const
template<class StrategyType >
void | cleanTopByChainCriterion (StrategyType &strat)

## Public Attributes

PairStatusSet | status
queue_type | queue

## Protected Member Functions

Pair | popped ()
| `top()` and `pop()` at once More...

## Detailed Description

This class defines PairManager.

## Member Typedef Documentation

typedef std::priority_queue<Pair, std::vector<PairE>, PairECompare> polybori::groebner::PairManager::queue_type

## Constructor & Destructor Documentation

polybori::groebner::PairManager::PairManager | ( | const BoolePolyRing & | ring | ) |

inline

## Member Function Documentation

void polybori::groebner::PairManager::appendHiddenGenerators | ( | std::vector< Polynomial > & | vec | ) |

inline

Referenced by polybori::groebner::GroebnerStrategy::allGenerators().

template<class StrategyType >

void polybori::groebner::PairManager::cleanTopByChainCriterion | ( | StrategyType & | strat | ) |

inline

void polybori::groebner::PairManager::introducePair | ( | const Pair & | pair,
|  | bool | isHFE
| ) |  |

inline

Polynomial polybori::groebner::PairManager::nextSpoly | ( | ReductionStrategy & | gen | ) |

inline

References polybori::groebner::ReductionTerms::leadingTerms, PBORI_UNLIKELY, polybori::CCuddDDFacade< RingType, DiagramType >::ring(), and polybori::BoolePolyRing::zero().

bool polybori::groebner::PairManager::pairSetEmpty | ( |  | ) | const

inline

Pair polybori::groebner::PairManager::popped | ( |  | ) |

inline protected

`top()` and `pop()` at once

## Member Data Documentation

queue_type polybori::groebner::PairManager::queue

Referenced by polybori::groebner::GroebnerStrategy::symmGB_F2().

PairStatusSet polybori::groebner::PairManager::status

Referenced by polybori::groebner::ChainCriterion::operator()(), polybori::groebner::CountCriterion::operator()(), polybori::groebner::ChainVariableCriterion::operator()(), and polybori::groebner::HasTRepOrExtendedProductCriterion::operator()().

The documentation for this class was generated from the following file:

- PairManager.h